#!/bin/sh

# Copyright (C) 2006-2012 Free Software Foundation, Inc.
#
# This file is part of GnuTLS.
#
# GnuTLS is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# GnuTLS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GnuTLS; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

#set -e

srcdir="${srcdir:-.}"
CERTTOOL="${CERTTOOL:-../../src/certtool${EXEEXT}}"
DIFF="${DIFF:-diff}"

export TZ="UTC"

# Check for datefudge
TSTAMP=`datefudge "2006-09-23" date -u +%s || true`
if test "$TSTAMP" != "1158969600"; then
	echo $TSTAMP
	echo "You need datefudge to run this test"
	exit 77
fi

# Note that in rare cases this test may fail because the
# time set using datefudge could have changed since the generation
# (if example the system was busy)

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-test.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-test.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 1 failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-utf8.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-utf8.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 2 (UTF8) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-dn.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-dn.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 3 (DN) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-dn-err.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null
rc=$?

if test "${rc}" = "0"; then
	echo "Test 3 (DN-err) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-overflow.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-overflow.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 4 (overflow1) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

# The following test works in 64-bit systems
if echo __SIZEOF_POINTER__ | cpp -E - - | grep '^8$' >/dev/null; then

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-overflow2.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-overflow2.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 5 (overflow2) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem
fi

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-date.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-date.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 6 (explicit dates) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

# Test name constraints generation

rc=1
counter=1

while [ "${rc}" != "0" -a $counter -le 3 ]; do
	datefudge "2007-04-22" \
	"${CERTTOOL}" --generate-self-signed \
		--load-privkey "${srcdir}/template-test.key" \
		--template "${srcdir}/template-nc.tmpl" \
		--outfile tmp-tt.pem 2>/dev/null

	${DIFF} "${srcdir}/template-nc.pem" tmp-tt.pem >/dev/null 2>&1
	rc=$?
	test ${rc} != 0 && sleep 3
	counter=`expr $counter + 1`
done

# We're done.
if test "${rc}" != "0"; then
	echo "Test 7 (name constraints) failed"
	exit ${rc}
fi

rm -f tmp-tt.pem

# Test the GeneralizedTime support
if test "$(getconf LONG_BIT)" = "64"; then
	# we should test that on systems which have 64-bit time_t.
	rc=1
	counter=1

	while [ "${rc}" != "0" -a $counter -le 3 ]; do
		datefudge "2051-04-22" \
			"${CERTTOOL}" --generate-self-signed \
				--load-privkey "${srcdir}/template-test.key" \
				--template "${srcdir}/template-generalized.tmpl" \
				--outfile tmp-tt.pem 2>/dev/null

		${DIFF} "${srcdir}/template-generalized.pem" tmp-tt.pem >/dev/null 2>&1
		rc=$?
		test ${rc} != 0 && sleep 3
		counter=`expr $counter + 1`
	done

	# We're done.
	if test "${rc}" != "0"; then
		echo "Test 8 (generalizedTime) failed"
		exit ${rc}
	fi
fi

rm -f tmp-tt.pem

exit 0
